diff --git a/vhdlparser/vhdlparser.jj b/vhdlparser/vhdlparser.jj
index fbae037..7611dd9 100644
--- a/vhdlparser/vhdlparser.jj
+++ b/vhdlparser/vhdlparser.jj
@@ -10,7 +10,8 @@
  *
  */
 options {
-  JAVA_UNICODE_ESCAPE = true;
+  JAVA_UNICODE_ESCAPE = false;
+  UNICODE_INPUT = true;
   OUTPUT_LANGUAGE = "c++";
   NAMESPACE = "vhdl::parser";
   STATIC=false;
@@ -32,13 +33,13 @@ static Entry* tempEntry;
 static Entry*  lastEntity  ;
 static Entry*  lastCompound  ;
 static Entry*  current;
-static QCString compSpec;
-static QCString currName;
+static VhdlString compSpec;
+static VhdlString currName;
 static int levelCounter;
-static QCString confName;
-static QCString genLabels;
-static QCString lab;
-static QCString forL;
+static VhdlString confName;
+static VhdlString genLabels;
+static VhdlString lab;
+static VhdlString forL;
 static int param_sec ;
 static int parse_sec;
 static int currP;
@@ -61,13 +62,13 @@ static void handleFlowComment(const char*);
 static void initEntry(Entry *e);
 static  void newEntry();
 static  bool isFuncProcProced();
-static void pushLabel(QCString &,QCString&);
-static  QCString popLabel(QCString & q);
-static  bool addLibUseClause(const QCString &type);
+static void pushLabel(VhdlString &,VhdlString&);
+static  VhdlString popLabel(VhdlString & q);
+static  bool addLibUseClause(const VhdlString &type);
 static  void mapLibPackage( Entry* root);
 static void createFlow();
 static void error_skipto(int kind);
-static void oneLineComment(QCString qcs);
+static void oneLineComment(VhdlString qcs);
 static void setMultCommentLine();
 PARSER_END(VhdlParser)
 
@@ -87,16 +89,15 @@ SKIP:
   | <MULT_DOXYGEN_COMMENT: (<DOXYGEN_VHDL_COMMENT>)+ >
   {
     {
-    QCString doc(image.data());
+    VhdlString doc(image);
     int count=doc.contains("--!");
     ::vhdl::parser::VhdlParser::setMultCommentLine();
     ::vhdl::parser::VhdlParser::lineCount(image.data());
     if (count == 1)
       ::vhdl::parser::VhdlParser::oneLineComment(doc);
     else
-      ::vhdl::parser::VhdlParser::handleCommentBlock(image.data(),FALSE); ;
+      ::vhdl::parser::VhdlParser::handleCommentBlock(doc.data(),FALSE); ;
     }
-
   }
   |<VHDL_FLOWCHART_COMMENT: "--#" (~["\n", "\r"])* ("\n" | "\r" | "\r\n")?>  { ::vhdl::parser::VhdlParser::handleFlowComment(image.data());}
   |<VHDL_COMMENT: "--" (~["\n", "\r"])* ("\n" | "\r" | "\r\n")?>
@@ -111,15 +112,17 @@ SKIP :
   <MULT_DOXYGEN_VHDL_COMMENT_2008 : "/*!"  (~[])* "*/" >
   {
    {
-     QCString q(image.data());
+     VhdlString q(image);
      q.stripPrefix("/*!");
      q.resize(q.length()-2);
      ::vhdl::parser::VhdlParser::handleCommentBlock(q.data(),TRUE);image.clear();
    }
   }
-  | <MULT_VHDL_2008_COMMENT : "/*"  (~[])* "*/" >  {::vhdl::parser::VhdlParser::lineCount(image.data());image.clear();}
+  | <MULT_VHDL_2008_COMMENT : "/*" (~[])*  "*/">  {
+	  ::vhdl::parser::VhdlParser::lineCount(image.data());image.clear();
 	  }
-
+}
+// <"/*" (~["*"])* "*" ("*" | ~["*","/"] (~["*"])* "*")* "/">
 /* KEYWORDS */
 
 TOKEN [IGNORE_CASE] :
@@ -307,7 +310,7 @@ TOKEN:
  | <#BASE_SPECIFIER:["B","O","X","b","o","x"]>
  | < #DIGIT: ["0"-"9"] >
  | < #SPECIAL_CHARACTER: ["#","&","'","(",")","*","+",",","-",".","/",":",";","<","=",">","_","|"] >
- | < #OTHER_SPECIAL_CHARACTER: ["%","!","$","@","?","[","\\","]","^","`","{","}","~","\u00A0"-"\u00FF"]>
+ | < #OTHER_SPECIAL_CHARACTER: ["%","!","$","@","?","[","\\","]","^","`","{","}","~"," ","¡", "¢", "£", "¤", "¥", "¦", "§","¨", "©", "ª", "«", "¬", "­", "®", "¯","°", "±", "²", "³", "´", "µ", "¶", "·","¸", "¹", "º", "»", "¼", "½", "¾", "¿","À", "Á", "Â", "Ã", "Ä", "Å", "Æ", "Ç","È", "É", "Ê", "Ë", "Ì", "Í", "Î", "Ï","Ð", "Ñ", "Ò", "Ó", "Ô", "Õ", "Ö", "×","Ø", "Ù", "Ú", "Û", "Ü", "Ý", "Þ", "ß","à", "á", "â", "ã", "ä", "å", "æ", "ç","è", "é", "ê", "ë", "ì", "í", "î", "ï","ð", "ñ", "ò", "ó", "ô", "õ", "ö", "÷","ø", "ù", "ú", "û", "ü", "ý", "þ", "ÿ","\u0100"-"\uFFFF" ] >
  | < #SPACE_CHARACTER: [" ","\t"] >
  | < #LOWER_CASE_LETTER: ["a"-"z"] >
  | < #QUOTE: ["\""] >
@@ -315,7 +318,7 @@ TOKEN:
 
 }
 
-QCString abstract_literal() :
+VhdlString abstract_literal() :
 {Token *tok;}
 {
    tok=<DECIMAL_LITERAL> { return tok->image.c_str(); }
@@ -323,14 +326,14 @@ QCString abstract_literal() :
  | tok=<BASED_LITERAL>   { return tok->image.c_str(); }
 }
 
-QCString access_type_definition() :
-{Token *tok=0;QCString str,str1;}
+VhdlString access_type_definition() :
+{Token *tok=0;VhdlString str,str1;}
 {
   tok=<ACCESS_T> str1=subtype_indication() { str=tok->image.c_str(); return str+str1; }
 }
 
-QCString actual_designator() :
-{QCString str;Token *t=0;}
+VhdlString actual_designator() :
+{VhdlString str;Token *t=0;}
 {
 t=<OPEN_T> { return t->image.c_str(); }
 |
@@ -341,14 +344,14 @@ LOOKAHEAD(expression())
  str=name() { return str; }
 }
 
-QCString actual_parameter_part() :
-{QCString s;}
+VhdlString actual_parameter_part() :
+{VhdlString s;}
 {
    s=association_list() { return s;}
 }
 
-QCString actual_part() :
-{QCString s,s1;}
+VhdlString actual_part() :
+{VhdlString s,s1;}
 {
  LOOKAHEAD(actual_designator())
  s=actual_designator() { return s;}
@@ -359,7 +362,7 @@ QCString actual_part() :
 
  }
 
-QCString adding_operator () :
+VhdlString adding_operator () :
 {}
 {
   <PLUS_T> { return "+";}
@@ -367,12 +370,12 @@ QCString adding_operator () :
   |<AMPERSAND_T> { return "&";}
 }
 
-QCString aggregate() :  {QCString s,s1,s2;}
+VhdlString aggregate() :  {VhdlString s,s1,s2;}
 {
   <LPAREN_T> s=element_association() (<COMMA_T> s1=element_association(){s+=","+s1;})* <RPAREN_T> { return "("+s+")";}
 }
 
-QCString alias_declaration() :  {QCString s,s1,s2;}
+VhdlString alias_declaration() :  {VhdlString s,s1,s2;}
 {
  <ALIAS_T> s2=alias_designator()
  [ <COLON_T>{ s+=":"; } s1=subtype_indication() { s+=s1; }]
@@ -385,7 +388,7 @@ QCString alias_declaration() :  {QCString s,s1,s2;}
 }
  }
 
-QCString alias_designator()  : {Token *tok=0;QCString s;}
+VhdlString alias_designator()  : {Token *tok=0;VhdlString s;}
 {
  s=identifier() { return s;}
  | tok=<CHARACTER_LITERAL> { return tok->image.c_str(); }
@@ -399,16 +402,16 @@ void allocator()  :{}
  |  <NEW_T>  subtype_indication()
 }
 
-void architecture_body() : {QCString s,s1;}
+void architecture_body() : {VhdlString s,s1;}
 {
 
     <ARCHITECTURE_T> s=identifier() <OF_T> s1=name() <IS_T>
     {
-                  QCString t=s1+"::"+s;
+                  VhdlString t=s1+"::"+s;
                   genLabels.resize(0);
                   pushLabel(genLabels,s1);
                   lastCompound=current;
-                  addVhdlType(t,getLine(ARCHITECTURE_T),Entry::CLASS_SEC,VhdlDocGen::ARCHITECTURE,0,0,Private);
+                  addVhdlType(t.data(),getLine(ARCHITECTURE_T),Entry::CLASS_SEC,VhdlDocGen::ARCHITECTURE,0,0,Private);
     }
    try{
    architecture_declarative_part()
@@ -431,7 +434,7 @@ void architecture_statement_part() :  {}
  // | (<VHDL2008TOOLDIR>)
 }
 
-QCString array_type_definition ():  { QCString s;}
+VhdlString array_type_definition ():  { VhdlString s;}
 {
 
  LOOKAHEAD(unconstraint_array_definition())
@@ -441,7 +444,7 @@ QCString array_type_definition ():  { QCString s;}
 
 }
 
-QCString assertion() :  {QCString s,s1,s2;Token *t=0;Token *t1=0;}
+VhdlString assertion() :  {VhdlString s,s1,s2;Token *t=0;Token *t1=0;}
 {
    <ASSERT_T> s=condition() [ t=<REPORT_T> s1=expression() ] [t1=<SEVERITY_T> s2=expression()]
  {
@@ -452,7 +455,7 @@ QCString assertion() :  {QCString s,s1,s2;Token *t=0;Token *t1=0;}
  }
 }
 
-QCString assertion_statement() :  {QCString s,s1,s2;Token *t=0;}
+VhdlString assertion_statement() :  {VhdlString s,s1,s2;Token *t=0;}
 {
   [ s=label() t=<COLON_T> ] s1=assertion() <SEMI_T>
   {
@@ -460,18 +463,18 @@ QCString assertion_statement() :  {QCString s,s1,s2;Token *t=0;}
     return s+s1+";";
   }
 }
-QCString association_element() : {QCString s,s1;}
+VhdlString association_element() : {VhdlString s,s1;}
 {
  [LOOKAHEAD(formal_part() <ARROW_T>) s=formal_part() <ARROW_T> ] s1=actual_part()
  { return s+" => "+s1;}
 }
 
-QCString association_list ():  {QCString s,s1;}
+VhdlString association_list ():  {VhdlString s,s1;}
 {
 s=association_element() (<COMMA_T> s1=association_element() { s+=","+s1; })* { return s; }
 }
 
-QCString attribute_declaration() : {QCString s,s1;}
+VhdlString attribute_declaration() : {VhdlString s,s1;}
 {
  <ATTRIBUTE_T> s=identifier() <COLON_T> s1=type_mark() <SEMI_T>
   {
@@ -480,55 +483,55 @@ QCString attribute_declaration() : {QCString s,s1;}
   }
  }
 
-QCString attribute_designator (): {QCString s;Token *tok=0;}
+VhdlString attribute_designator (): {VhdlString s;Token *tok=0;}
 {
   s=identifier() { return s;}
   | tok=<RANGE_T> { return tok->image.c_str(); }
 }
 
-QCString attribute_name (): {QCString s,s1;}
+VhdlString attribute_name (): {VhdlString s,s1;}
 {
   s=identifier() <APOSTROPHE_T> s1=name(){ s+="'"+s1; }[LOOKAHEAD(1)<LPAREN_T>s1=expression() <RPAREN_T> {s+"("+s1+")";}] { return s; }
 }
 
 
-QCString attribute_specification():  {QCString s,s1,s2;}
+VhdlString attribute_specification():  {VhdlString s,s1,s2;}
 {
   <ATTRIBUTE_T> s=attribute_designator() <OF_T> s1=entity_specification() <IS_T> s2=expression() <SEMI_T>
   {
-   QCString t= s1+" is "+s2;
+   VhdlString t= s1+" is "+s2;
    addVhdlType(s.data(),getLine(ATTRIBUTE_T),Entry::VARIABLE_SEC,VhdlDocGen::ATTRIBUTE,0,t.data(),Public);
    return " attribute "+s+" of "+s1+ " is "+s2+";";
   }
 }
 
-QCString base() :  {Token *tok=0;}
+VhdlString base() :  {Token *tok=0;}
 {
   tok=<INTEGER> { return tok->image.c_str();}
 }
 
-QCString base_specifier ():  {Token *tok=0;}
+VhdlString base_specifier ():  {Token *tok=0;}
 {
    tok=<BASIC_IDENTIFIER> { return tok->image.c_str();}
 }
 
-QCString base_unit_declaration() :
-{QCString s;}
+VhdlString base_unit_declaration() :
+{VhdlString s;}
 {
   s=identifier() { return s; }
 }
 
-QCString based_integer() :  {Token *tok=0;}
+VhdlString based_integer() :  {Token *tok=0;}
 {
   tok=<BASIC_IDENTIFIER> { return tok->image.c_str();}
 }
 
-QCString based_literal():  {Token *tok=0;}
+VhdlString based_literal():  {Token *tok=0;}
 {
  tok=<BASED_LITERAL> { return tok->image.c_str();}
 }
 
-QCString basic_identifier() :  {Token *tok=0;}
+VhdlString basic_identifier() :  {Token *tok=0;}
 {
   tok=<BASIC_IDENTIFIER> { return tok->image.c_str();}
 }
@@ -540,13 +543,13 @@ void binding_indication() :  {}
  [ port_map_aspect() ]
 }
 
-QCString bit_string_literal ():  {Token *tok=0;}
+VhdlString bit_string_literal ():  {Token *tok=0;}
 {
   tok=<BIT_STRING_LITERAL> { return tok->image.c_str();}
 }
 
 
-QCString bit_value() :  {Token *tok=0;}
+VhdlString bit_value() :  {Token *tok=0;}
 {
   tok=<BASIC_IDENTIFIER> { return tok->image.c_str();}
 }
@@ -601,7 +604,7 @@ void block_specification() :  {}
   name()[LOOKAHEAD(1) <LPAREN_T> index_specification() <RPAREN_T>]
 }
 
-void block_statement() :  {QCString s;}
+void block_statement() :  {VhdlString s;}
 {
   s=identifier() <COLON_T>
         <BLOCK_T> { pushLabel(genLabels,s); }[ <LPAREN_T> expression() <RPAREN_T> ] [ <IS_T> ]
@@ -620,13 +623,13 @@ void block_statement_part() :  {}
   ( concurrent_statement() )*
 }
 
-void  case_statement() : {QCString s;}
+void  case_statement() : {VhdlString s;}
 {
 [ identifier() <COLON_T> ]
   <CASE_T> s=expression()
     {
-     QCString ca="case "+s;
-     FlowChart::addFlowChart(FlowChart::CASE_NO,0,ca);
+     VhdlString ca="case "+s;
+     FlowChart::addFlowChart(FlowChart::CASE_NO,0,ca.data());
     }
   <IS_T>
         case_statement_alternative()
@@ -638,23 +641,23 @@ void  case_statement() : {QCString s;}
           }
 }
 
-void case_statement_alternative() :  {QCString s;}
+void case_statement_alternative() :  {VhdlString s;}
 {
   <WHEN_T> s=choices() <ARROW_T>
    {
-    QCString t="when ";
+    VhdlString t="when ";
     t+=s+"=> ";
-    FlowChart::addFlowChart(FlowChart::WHEN_NO,s.data(),t);
+    FlowChart::addFlowChart(FlowChart::WHEN_NO,s.data(),t.data());
     }
   sequence_of_statement(){FlowChart::moveToPrevLevel(); }
 }
 
-QCString character_literal() :  {Token *tok=0;}
+VhdlString character_literal() :  {Token *tok=0;}
 {
   tok=<CHARACTER_LITERAL>{ return tok->image.c_str();}
 }
 
-QCString choice() : {QCString s;}
+VhdlString choice() : {VhdlString s;}
 {
   LOOKAHEAD(discrete_range())
   s=discrete_range(){ return s; }
@@ -667,7 +670,7 @@ QCString choice() : {QCString s;}
   | <OTHER_T> { return " others "; }
 }
 
-QCString choices() :  {QCString s,s1;}
+VhdlString choices() :  {VhdlString s,s1;}
 {
   s=choice() (<BAR_T> s1=choice(){s+="|";s+=s1;})* { return s; }
 }
@@ -679,7 +682,7 @@ void component_configuration () :{}
         [ block_configuration() ]
     <END_T> <FOR_T> <SEMI_T>
 }
-void component_declaration() :  {QCString s;}
+void component_declaration() :  {VhdlString s;}
 {
  <COMPONENT_T> s=identifier() [ <IS_T> ]
    { currP=VhdlDocGen::COMPONENT; }
@@ -693,13 +696,13 @@ void component_declaration() :  {QCString s;}
 
 }
 
-void component_instantiation_statement() :  {QCString s,s1;}
+void component_instantiation_statement() :  {VhdlString s,s1;}
 {
 
 s=identifier() <COLON_T>
  s1=instantiation_unit()
  {
-       QCString s3;
+       VhdlString s3;
        if (s1.contains("|")) {
          s3=VhdlDocGen::getIndexWord(s1.data(),0);
          s1=VhdlDocGen::getIndexWord(s1.data(),1);
@@ -716,7 +720,7 @@ void component_specification() :  {}
 instantiation_list() <COLON_T> name()
 }
 
-QCString composite_type_definition() :  { QCString s,s1;}
+VhdlString composite_type_definition() :  { VhdlString s,s1;}
 {
  s=array_type_definition(){ return s; }
 | record_type_definition(){ return s+"#"; }
@@ -778,12 +782,12 @@ concurrent_procedure_call_statement()
  */
 }
 
-QCString condition() :  {QCString s;}
+VhdlString condition() :  {VhdlString s;}
 {
   s=expression() { return s; }
 }
 
-QCString condition_clause() :  {QCString s;}
+VhdlString condition_clause() :  {VhdlString s;}
 {
   <UNTIL_T> s=condition()
   {
@@ -813,7 +817,7 @@ waveform()
     //    <WHEN> condition() <ELSE> waveform() )*
     //[ <WHEN> condition() ]
 
-void configuration_declaration() :  {QCString s,s1;}
+void configuration_declaration() :  {VhdlString s,s1;}
 {
  <CONFIGURATION_T> s=identifier() <OF_T> s1=name() <IS_T>
   {
@@ -852,20 +856,20 @@ void configuration_specification() :  {}
 <FOR_T> component_specification() binding_indication() <SEMI_T>
 }
 
-QCString constant_declaration() :  {QCString s,s1,s2;Token *t=0;}
+VhdlString constant_declaration() :  {VhdlString s,s1,s2;Token *t=0;}
 {
    <CONSTANT_T> s=identifier_list() <COLON_T> s1= subtype_indication() [ t=<VARASSIGN_T> s2=expression() ] <SEMI_T>
     {
      if(t)
       s2.prepend(":=");
-     QCString it=s1+s2;
+     VhdlString it=s1+s2;
      addVhdlType(s.data(),getLine(CONSTANT_T),Entry::VARIABLE_SEC,VhdlDocGen::CONSTANT,0,it.data(),Public);
      it.prepend("constant ");
      return it;
     }
 }
 
-QCString constraint_array_definition (): {QCString s,s1;}
+VhdlString constraint_array_definition (): {VhdlString s,s1;}
 {
 <ARRAY_T> s=index_constraint() <OF_T> s1=subtype_indication(){ return s+" "+s1;}
 }
@@ -875,7 +879,7 @@ void context_clause (): {}
  (context_item())*
 }
 
-QCString constraint () :{QCString s;}
+VhdlString constraint () :{VhdlString s;}
  {
     LOOKAHEAD(range_constraint())
     s=range_constraint(){ return s;}
@@ -890,13 +894,13 @@ void context_item() :  {}
 | use_clause()
 }
 
-QCString decimal_literal() :  {Token *tok=0;}
+VhdlString decimal_literal() :  {Token *tok=0;}
 {
  tok=<DECIMAL_LITERAL> { return tok->image.c_str(); }
 }
 
 
-QCString delay_mechanism ():  {QCString s;}
+VhdlString delay_mechanism ():  {VhdlString s;}
 {
 <TRANSPORT_T> { return " transport ";}
 | [ <REJECT_T> s=expression() {s.prepend(" reject ");}] <INERTIAL_T> { return s+" inertial "; }
@@ -914,13 +918,13 @@ void design_unit() :  {}
 
 }
 
-QCString designator() : {QCString s;}
+VhdlString designator() : {VhdlString s;}
 {
  s=identifier()          {return s;}
  | s=operator_symbol(){return s;}
 }
 
-QCString direction ():  {Token *tok=0;}
+VhdlString direction ():  {Token *tok=0;}
 {
 tok=<TO_T>  { return tok->image.c_str();}
 | tok=<DOWNTO_T> { return tok->image.c_str();}
@@ -936,7 +940,7 @@ void guarded_signal_specificatio() : {}
  signal_list() <COLON_T> name()
 }
 
-QCString discrete_range() : {QCString s;}
+VhdlString discrete_range() : {VhdlString s;}
 {
   LOOKAHEAD(range())
   s=range() { return s;}
@@ -945,7 +949,7 @@ QCString discrete_range() : {QCString s;}
    s=subtype_indication() { return s;}
 }
 
-QCString element_association() :  {QCString s,s1;}
+VhdlString element_association() :  {VhdlString s,s1;}
 {
 [LOOKAHEAD(choices() <ARROW_T>) s=choices() <ARROW_T> ]  s1=expression()
  {
@@ -955,7 +959,7 @@ return s1;
  }
 }
 
-QCString element_declaration() :  {QCString s,s1;}
+VhdlString element_declaration() :  {VhdlString s,s1;}
 {
 s=identifier_list() <COLON_T> s1=subtype_indication() <SEMI_T>
 {
@@ -967,14 +971,14 @@ s=identifier_list() <COLON_T> s1=subtype_indication() <SEMI_T>
 }
 
 
-QCString entity_aspect() :  {Token *tok=0;QCString s,s1;}
+VhdlString entity_aspect() :  {Token *tok=0;VhdlString s,s1;}
 {
 tok=<ENTITY_T> s=name() [ LOOKAHEAD(1)<LPAREN_T> s1=identifier() <RPAREN_T> {s+="("+s1+")";} ] { return s;}
 | tok=<CONFIGURATION_T> s=name() { return tok->image.c_str()+s;}
 | tok=<OPEN_T> { return tok->image.c_str(); }
 }
 
-QCString entity_class() :  {}
+VhdlString entity_class() :  {}
 {
 <ENTITY_T> { return "entity";}
 | <ARCHITECTURE_T> {return "architecture";}
@@ -995,17 +999,17 @@ QCString entity_class() :  {}
 | <FILE_T>  {return "file";}
 }
 
-QCString entity_class_entry() :  {QCString s;}
+VhdlString entity_class_entry() :  {VhdlString s;}
 {
  s=entity_class() [ <BOX_T> {s+="<>";} ] { return s;}
 }
 
-QCString entity_class_entry_list() :  {QCString s,s1,s2;}
+VhdlString entity_class_entry_list() :  {VhdlString s,s1,s2;}
 {
  ( s1=entity_class_entry() {s+=s1;} )(<COMMA_T> s=entity_class_entry(){s2+=",";s2+=s;}  )* { return s1+s2;}
 }
 
-void entity_declaration() :  {QCString s;}
+void entity_declaration() :  {VhdlString s;}
 {
    // try{
     <ENTITY_T> s=identifier()  <IS_T>
@@ -1056,7 +1060,7 @@ void entity_declarative_part() : {}
   (entity_declarative_item() )*
 }
 
-QCString entity_designator() :  {QCString s,s1;}
+VhdlString entity_designator() :  {VhdlString s,s1;}
 {
 s=entity_tag() [ s1=signature() ] { return s+s1;}
 }
@@ -1067,14 +1071,14 @@ void entity_header() : {}
  [ { currP=VhdlDocGen::PORT; } port_clause()]
 }
 
-QCString entity_name_list() :  {QCString s,s1;}
+VhdlString entity_name_list() :  {VhdlString s,s1;}
 {
 (s1=entity_designator() {s+=s1;})+ { return s;}
 | <OTHER_T> { return "other";}
 | <ALL_T> {return "all";}
 }
 
-QCString entity_specification() :  {QCString s,s1;}
+VhdlString entity_specification() :  {VhdlString s,s1;}
 {
 s=entity_name_list() <COLON_T> s1=entity_class(){ return s+":"+s1;}
 }
@@ -1096,25 +1100,25 @@ void entity_statement_part() :  {}
 }
 
 
-QCString entity_tag ():  {QCString s;}
+VhdlString entity_tag ():  {VhdlString s;}
 {
 s=name() { return s;}
 | s=character_literal() { return s;}
 }
 
-QCString enumeration_literal() :  {QCString s;}
+VhdlString enumeration_literal() :  {VhdlString s;}
 {
  s=identifier() { return s;}
  | s=character_literal() { return s;}
 }
 
-QCString enumeration_type_definition() : {QCString s,s1;}
+VhdlString enumeration_type_definition() : {VhdlString s,s1;}
 {
   <LPAREN_T>s=enumeration_literal() (LOOKAHEAD(1)<COMMA_T> s1=enumeration_literal() {s+=",";s+=s1;} )* <RPAREN_T>
   { return "("+s+")";}
 }
 
-QCString exit_statement() :  {QCString s,s1,s2;Token *t=0;Token *t1=0;}
+VhdlString exit_statement() :  {VhdlString s,s1,s2;Token *t=0;Token *t1=0;}
 {
 [ s=identifier() t=<COLON_T> ] <EXIT_T> [ s1=identifier() ]
 [ t1=<WHEN_T> s2=condition() ] <SEMI_T>
@@ -1128,13 +1132,13 @@ QCString exit_statement() :  {QCString s,s1,s2;Token *t=0;Token *t1=0;}
 }
 }
 
-QCString expression ():  {QCString s,s1,s2;}
+VhdlString expression ():  {VhdlString s,s1,s2;}
 {
 s=relation() ( s1=logop() s2=relation() {s+=s1;s+=s2;} )*
 { return s; }
 }
 
-QCString logop() : {}
+VhdlString logop() : {}
 {
   <AND_T> { return "and" ;}
   |<NAND_T> { return "nand" ;}
@@ -1144,66 +1148,66 @@ QCString logop() : {}
   |<OR_T> { return "or" ;}
  }
 
-QCString extended_identifier ():  {Token *t;}
+VhdlString extended_identifier ():  {Token *t;}
 {
  t=<EXTENDED_CHARACTER> { return t->image.c_str(); }
 }
 
-QCString factor():  {QCString s,s1;}
+VhdlString factor():  {VhdlString s,s1;}
 {
 s=primary() [LOOKAHEAD(1) <DOUBLEMULT_T> s1=primary(){ s+="**";s+=s1;} ] { return s;}
 | <ABS_T> s=primary(){ s1 = "abs "; return s1+s; }
 | <NOT_T>  s=primary(){s1="not ";return s1+s;}
 }
 
-QCString file_declaration() :  {QCString s,s1,s2,s3;}
+VhdlString file_declaration() :  {VhdlString s,s1,s2,s3;}
 {
  <FILE_T> s=identifier_list() <COLON_T> s2=subtype_indication() [ s3=file_open_information() ] <SEMI_T>
    {
-   QCString t1=s2+" "+s3;
+   VhdlString t1=s2+" "+s3;
    addVhdlType(s.data(),getLine(),Entry::VARIABLE_SEC,VhdlDocGen::VFILE,0,t1.data(),Public);
    return " file "+s+":"+s2+" "+s3+";";
    }
  }
 
-QCString  file_logical_name():  {QCString s;}
+VhdlString  file_logical_name():  {VhdlString s;}
 {
  s=expression() { return s; }
 }
 
-QCString file_open_information() :  {QCString s,s1,s2;}
+VhdlString file_open_information() :  {VhdlString s,s1,s2;}
 {
  [ <OPEN_T> s=expression() ] <IS_T> s1=file_logical_name() {s2="open "+s+" is "+s1;  return s2; }
 }
 
-QCString file_type_definition() :  {QCString s,s1;}
+VhdlString file_type_definition() :  {VhdlString s,s1;}
 {
  <FILE_T> <OF_T> s=type_mark() { s1=" file of "+s; return s1;}
 }
 
-QCString floating_type_definition() :  {QCString s;}
+VhdlString floating_type_definition() :  {VhdlString s;}
 {
   s=range_constraint(){ return s;}
 }
 
-QCString formal_designator() : {QCString s;Token *tok=0;}
+VhdlString formal_designator() : {VhdlString s;Token *tok=0;}
 {
     s=name()  { return s; }
     |tok=<INTEGER> { return tok->image.c_str();}
 }
 
 
-QCString formal_parameter_list() :  {QCString s;}
+VhdlString formal_parameter_list() :  {VhdlString s;}
 {
  s=interface_list(){ return s; }
 }
 
-QCString formal_part() : {QCString s,s1;}
+VhdlString formal_part() : {VhdlString s,s1;}
 {
 s=name() [<LPAREN_T> formal_designator() <RPAREN_T> {s+"("+s1+")";}] {return s;}
 }
 
-QCString full_type_declaration() :  {Entry *tmpEntry;QCString s,s1,s2;}
+VhdlString full_type_declaration() :  {Entry *tmpEntry;VhdlString s,s1,stype;}
 {
 <TYPE_T> s=identifier() <IS_T>
 {
@@ -1211,38 +1215,40 @@ QCString full_type_declaration() :  {Entry *tmpEntry;QCString s,s1,s2;}
   addVhdlType(s.data(),getLine(),Entry::VARIABLE_SEC,VhdlDocGen::RECORD,0,0,Public);
 }
  try{
-     s2=type_definition()
+     stype=type_definition()
        }catch(...){error_skipto(SEMI_T);}
      <SEMI_T>
      {
+     
+      QCString s2=stype.data();
       if (s2.contains("#")) {
         VhdlDocGen::deleteAllChars(s2,'#');
         tmpEntry->spec=VhdlDocGen::RECORD;
         tmpEntry->type=s2.data();
-        //addVhdlType(s.data(),getLine(TYPE_T),Entry::VARIABLE_SEC,VhdlDocGen::RECORD,0,s2.data(),Public);
+        addVhdlType(s.data(),getLine(TYPE_T),Entry::VARIABLE_SEC,VhdlDocGen::RECORD,0,s2.data(),Public);
       }
       else if (s2.contains("%")) {
         VhdlDocGen::deleteAllChars(s2,'%');
         tmpEntry->spec=VhdlDocGen::UNITS;
         tmpEntry->type=s2.data();
-        //addVhdlType(s.data(),getLine(TYPE_T),Entry::VARIABLE_SEC,VhdlDocGen::UNITS,s2.data(),s2.data(),Public);
+        addVhdlType(s.data(),getLine(TYPE_T),Entry::VARIABLE_SEC,VhdlDocGen::UNITS,s2.data(),s2.data(),Public);
       }
       else {
         tmpEntry->spec=VhdlDocGen::TYPE;
         tmpEntry->type=s2.data();
-        //addVhdlType(s.data(),getLine(TYPE_T),Entry::VARIABLE_SEC,VhdlDocGen::TYPE,0,s2.data(),Public);
+        addVhdlType(s.data(),getLine(TYPE_T),Entry::VARIABLE_SEC,VhdlDocGen::TYPE,0,s2.data(),Public);
       }
       tmpEntry=0;
-      return "type "+s+" is "+s2+";";
+       return "type "+s+" is "+s2.data()+";";
      }
 }
 
-QCString function_call() :  {QCString s,s1;}
+VhdlString function_call() :  {VhdlString s,s1;}
 {
 s=name()  <LPAREN_T> s1=actual_parameter_part()  <RPAREN_T> { return s+"("+s1+")";}
 }
 
-void generate_statement() :  {QCString s;}
+void generate_statement() :  {VhdlString s;}
 {
 s=identifier() <COLON_T>
           try{
@@ -1260,12 +1266,12 @@ void generate_scheme() : {}
 | <IF_T> condition()
 }
 
-void generic_clause() : {QCString s;}
+void generic_clause() : {VhdlString s;}
 {
  <GENERIC_T>  <LPAREN_T> { parse_sec=GEN_SEC; } s=generic_list() <RPAREN_T> <SEMI_T> { parse_sec=0; }
 }
 
-QCString generic_list() :  {QCString s;}
+VhdlString generic_list() :  {VhdlString s;}
 {
  s=interface_list() { return s; }
 }
@@ -1275,18 +1281,18 @@ void generic_map_aspect() :  {}
      <GENERIC_T> <MAP_T> <LPAREN_T> association_list() <RPAREN_T>
 }
 
-QCString group_constituent() :  {QCString s;}
+VhdlString group_constituent() :  {VhdlString s;}
 {
  s=name() { return s; }
  | s=character_literal() { return s;}
 }
 
-QCString group_constituent_list() : {QCString s,s1,s2;}
+VhdlString group_constituent_list() : {VhdlString s,s1,s2;}
 {
   (s1=group_constituent())(<COMMA_T> s=group_constituent(){s2+=",";s2+=s1;})* { return s+s2;}
 }
 
-QCString group_declaration() :  {QCString s,s1,s2;}
+VhdlString group_declaration() :  {VhdlString s,s1,s2;}
 {
   <GROUP_T> s=identifier() <COLON_T> s1=identifier() <LPAREN_T> s2=group_constituent_list() <RPAREN_T> <SEMI_T>
   {
@@ -1294,7 +1300,7 @@ QCString group_declaration() :  {QCString s,s1,s2;}
   }
 }
 
-QCString group_template_declaration() : {QCString s,s1;}
+VhdlString group_template_declaration() : {VhdlString s,s1;}
 {
  <GROUP_T> s=identifier() <IS_T> <LPAREN_T> s1=entity_class_entry_list() <RPAREN_T> <SEMI_T>
   {
@@ -1307,24 +1313,24 @@ void guarded_signal_specification() : {}
  signal_list() <COLON_T> type_mark()
 }
 
-QCString identifier() : {Token *tok=0;}
+VhdlString identifier() : {Token *tok=0;}
 {
   tok=<EXTENDED_CHARACTER>{ return tok->image.c_str(); }
   |tok=<BASIC_IDENTIFIER> { return tok->image.c_str(); }
 }
 
-QCString identifier_list() : {QCString str,str1;}
+VhdlString identifier_list() : {VhdlString str,str1;}
 {
    str=identifier() (<COMMA_T> str1=identifier() {str+=",";str+=str1;})* { return str; }
 }
 
-void if_statement() :  {QCString s,s1;}
+void if_statement() :  {VhdlString s,s1;}
 {
 [LOOKAHEAD(1) identifier() <COLON_T> ]
     <IF_T> s=condition() <THEN_T>
     {
     s.prepend("if ");
-    FlowChart::addFlowChart(FlowChart::IF_NO,0,s);
+    FlowChart::addFlowChart(FlowChart::IF_NO,0,s.data());
   }
         sequence_of_statement()
         (
@@ -1346,7 +1352,7 @@ void if_statement() :  {QCString s,s1;}
         }
 }
 
-QCString incomplete_type_declaration() :  {QCString s;}
+VhdlString incomplete_type_declaration() :  {VhdlString s;}
 {
   <TYPE_T> s=identifier() <SEMI_T>
   {
@@ -1354,50 +1360,50 @@ QCString incomplete_type_declaration() :  {QCString s;}
   }
 }
 
-QCString index_constraint() :  {QCString s="("; QCString s1,s2;}
+VhdlString index_constraint() :  {VhdlString s="("; VhdlString s1,s2;}
 {
   //try{
   <LPAREN_T> s2=discrete_range(){s+=s2;}(LOOKAHEAD(1)<COMMA_T> s1=discrete_range(){s+=",";s+=s1;})*  <RPAREN_T> {return s+")";}
 //}catch(...){  error_skipto(SEMI_T);hasError=false;return "";}
   }
 
-QCString index_specification() : {QCString s;}
+VhdlString index_specification() : {VhdlString s;}
 {
  LOOKAHEAD( discrete_range())
  s=discrete_range() { return s;}
 | s=expression(){ return s;}
 }
 
-QCString index_subtype_definition() :  {QCString s;}
+VhdlString index_subtype_definition() :  {VhdlString s;}
 {
  s=type_mark() <RANGE_T> <BOX_T> { return s+" range <> ";}
 }
 
-QCString instantiation_unit() :  {QCString s,s1,s2;Token *tok;}
+VhdlString instantiation_unit() :  {VhdlString s,s1,s2;Token *tok;}
 {
 [ <COMPONENT_T> ] s=identifier() {s1="component "; return s; }
 | <ENTITY_T>  [LOOKAHEAD(2)<BASIC_IDENTIFIER> <DOT_T>] s2=name() {s="entity|"+s2;} [ <LPAREN_T> s1=identifier() <RPAREN_T> {s+="(";s+=s1;s+=")" ;}] { return s;}
 | <CONFIGURATION_T> s=name() {s1="configuration ";return s;}
 }
 
-QCString instantiation_list() : {QCString s;Token *tok=0;}
+VhdlString instantiation_list() : {VhdlString s;Token *tok=0;}
 {
   s=identifier_list() { return s;}
 | tok=<OTHER_T> {return tok->image.c_str();}
 | tok=<ALL_T> {return tok->image.c_str();}
 }
 
-QCString integer() :  {Token *t;}
+VhdlString integer() :  {Token *t;}
 {
   t=<INTEGER> {return t->image.c_str();}
 }
 
-QCString integer_type_definition() :  {QCString s;}
+VhdlString integer_type_definition() :  {VhdlString s;}
 {
   s=range_constraint(){ return s;}
 }
 
-QCString interface_declaration() :  {QCString s,s1;}
+VhdlString interface_declaration() :  {VhdlString s,s1;}
 {
 
 LOOKAHEAD(5)
@@ -1423,12 +1429,12 @@ subprogram_declaration() { return s;}
     }
 }
 
-QCString interface_element() :  {QCString s;}
+VhdlString interface_element() :  {VhdlString s;}
 {
 s=interface_declaration(){ return s;}
 }
 
-QCString interface_file_declaration() : {QCString s,s1;}
+VhdlString interface_file_declaration() : {VhdlString s,s1;}
 {
 <FILE_T> s=identifier_list() <COLON_T> s1=subtype_indication()
 {
@@ -1437,14 +1443,14 @@ QCString interface_file_declaration() : {QCString s,s1;}
 }
 }
 
-QCString interface_list() :  {QCString s,s1,s2;}
+VhdlString interface_list() :  {VhdlString s,s1,s2;}
 {
 s=interface_element() (LOOKAHEAD(1) <SEMI_T> s1=interface_element(){s2+=";";s2+=s1;})* { return s+s2;}
 }
 
 
 
-QCString interface_variable_declaration() :  {Token *tok=0;Token *tok1=0;Token *tok2=0;QCString s,s1,s2,s3,s4,s5;}
+VhdlString interface_variable_declaration() :  {Token *tok=0;Token *tok1=0;Token *tok2=0;VhdlString s,s1,s2,s3,s4,s5;}
 {
 [( tok=<VARIABLE_T> | tok=<SIGNAL_T> | tok=<CONSTANT_T>|tok=<SHARED_T>) ]
   s=identifier_list() <COLON_T> [ s1=mode() ]
@@ -1459,7 +1465,7 @@ QCString interface_variable_declaration() :  {Token *tok=0;Token *tok1=0;Token *
                     if(tok2)
                      s3+=":=";
 
-                    QCString it=s+":"+s1+" "+s2+" "+s3+" "+s4;
+                    VhdlString it=s+":"+s1+" "+s2+" "+s3+" "+s4;
                     if (currP!=VhdlDocGen::COMPONENT)
                     {
                       if (currP==VhdlDocGen::FUNCTION || currP==VhdlDocGen::PROCEDURE)
@@ -1468,7 +1474,7 @@ QCString interface_variable_declaration() :  {Token *tok=0;Token *tok1=0;Token *
                       }
                       else
                       {
-                        QCString i=s2+s3+s4;
+                        VhdlString i=s2+s3+s4;
                         if (currP==VhdlDocGen::GENERIC && param_sec==0)
                           addVhdlType(s.data(),getLine(),Entry::VARIABLE_SEC,currP,i.data(),s1.data(),Public);
                         else if(parse_sec != GEN_SEC)
@@ -1480,7 +1486,7 @@ QCString interface_variable_declaration() :  {Token *tok=0;Token *tok1=0;Token *
             }
 }
 
-QCString iteration_scheme() :  {QCString s;}
+VhdlString iteration_scheme() :  {VhdlString s;}
 {
 <WHILE_T> s=condition()
 {
@@ -1491,19 +1497,19 @@ QCString iteration_scheme() :  {QCString s;}
 }
 | <FOR_T> s=parameter_specification()
 {
-    QCString q=lab+" for "+s;
+    VhdlString q=lab+" for "+s;
     FlowChart::addFlowChart(FlowChart::FOR_NO,0,q.data(),lab.data());
     lab="";
     return q;
 }
 }
 
-QCString label() :  {QCString s;}
+VhdlString label() :  {VhdlString s;}
 {
  s=identifier() { return s;}
 }
 
-QCString library_clause() :  {QCString s;}
+VhdlString library_clause() :  {VhdlString s;}
 {
  (<LIBRARY_T> s=identifier_list() <SEMI_T>
  )
